#  DMACH - machine definitions for iAPX86: Linux
#  Copyright (C) 1985, 1987 by Michael J. Harrison
#  Written MJH, 14-Sep-85
#  Revised MJH, 25-Aug-86: Add 80287 stuff
#  Revised MJH, 28-Feb-87: Add MAXENVSTR
#  Revised MJH, 14-Mar-87: Support Microsoft FORTRAN 4.00
#  Revised MJH,  9-Aug-87: Add target machine definition
#  Revised MJH, 16-Apr-88: New define syntax
#  Revised MJH,  8-Sep-88: New definition of FILSEP
#  M.J.Harrison  3-Apr-98: For Linux

# Define target OS and/or compiler

define UNIX 1			# UNIX-like OS
define GFORTRAN 1		# GNU gfortran compiler (>= f95)
# define F2C 1			# UNIX f2c compiler
# define MSFORT4 1		# DOS (!) MS FORTRAN 4 compiler

# Processor-specific parameters:

# define WORDLEN 32		# Word length in bits
# define CHPERW 4		# Bytes per word
define BYTEMASK 255		# Mask int down to low 8 bits

# Operating system parameters:

define STDIN 0 			# Linux predefines 0 through 2
define STDOUT 1
define STDERR 2
define STDMAX 2			# Max predefined handle
define FILSEP 46		# Between fn and ext ('.' = 46)
define PATHSEP 47		# File path delimiter ('/')
define LENFN 256		# length of filename, + EOS
define LENFT 0 			# length of file ext, + EOS
define LENFULLFN 256		# length of fn.ext,   + EOS
define MAXFN LENFULLFN		# define a synonym
define LENPATH 256		# length of max path, incl EOS
define MAXARGL 128		# Max string length of a single command-line arg
define MAXENVSTR 128		# Max string length of DOS environment string

# System-dependent parameters that we choose:

define TEMPNM "ratfor temp file"	# Temp file name

ifdef F2C
# Redefine name of getarg primitive, which clashes with the
# f2c function of the same name.
define getarg getarg_rf
endif
