# balpar - copy balanced paren string
#
# Copyright (c) 1987 by Michael J. Harrison
#
# Revised MJH, 24-May-86: Support real CHARACTER variables
# Revised MJH, 16-Jun-86: Remove last traces of 'do (...)'
# Revised MJH, 10-Jan-87: Switch to common tokbuf array

include dstd
include drmax
include drmeta

subroutine balpar

include ctoken
intfunc gettok

    integer nlpar, t
    logical nullc

    if (gettok(tokbuf, MAXTOK) ^= LPAREN) {
	call synerr("Missing '('.")
	return
	}
    call outstr(tokbuf) 	# '('
    nullc = YES
    nlpar = 1
    while (nlpar > 0) {
	t = gettok(tokbuf, MAXTOK)
	if (t == EOF)
	    break
	if (t == SEMICOL | t == LBRACE | t == RBRACE) {
	    call pbstr(tokbuf)
	    break
	    }
	if (t == NEWLINE)	# delete NEWLINE's
	    tokbuf(1) = EOS
	else if (t == LPAREN)
	    nlpar = nlpar + 1
	else if (t == RPAREN)
	    nlpar = nlpar - 1
	else
	    nullc = NO
	call outstr(tokbuf)	# condition or ')'
	}
    if (nlpar ^= 0)
	call synerr("Missing ')' in condition.")
    if (nullc)
	call synerr("Null condition.")

    return
    end
