# defpk - routines for 'define' statement: circdf, define, getdef, undef
#
# Copyright (c) 1988 by Michael J. Harrison
#
# Revised MJH,	6-Jun-86: STDERR changed to STDOUT
# Revised MJH, 15-Jun-86: Add undef
# Revised MJH, 10-Jan-87: Switch to str... string functions
# Revised MJH, 11-Apr-88: Make define syntax like C's
# Revised MJH, 29-Dec-90: Adapt to changed interface for lookup

include dstd
include dmach	    # for STDOUT
include drmax
include drmeta

#----------------------------------------------------------------------
# define - get and install macro definition
#----------------------------------------------------------------------

subroutine define(tokstr, toksiz)
integer toksiz
character tokstr(toksiz)

logfunc getdef, instal
intfunc rdtok, strlen

    integer ic
    character defstr(MAXDEF)

    ic = rdtok(tokstr, toksiz)
    if (ic ^= ALPHA)
	call synerr("Invalid name in 'define'.")
    else {
	if (getdef(defstr, MAXDEF)) {
	    for (ic = strlen(defstr);
		 ic > 0 & (defstr(ic) == SPACE | defstr(ic) == TAB);
		 ic = ic - 1)
		;		# strip trailing white space
	    defstr(ic+1) = EOS
	    if (^instal(tokstr, defstr))
		call synerr("Name already defined.")
	    }
	}

    return
    end

#----------------------------------------------------------------------
# getdef -- get definition in 'define' statement
#----------------------------------------------------------------------

logical function getdef(defstr, defsiz)
integer defsiz
character defstr(defsiz)

intfunc ngetc		# Use ngetc to get totally raw input

    integer i, ic
    character c

    getdef = YES
    i = 1
    ic = ngetc(c)
    while (ic == SPACE | ic == TAB)	# Throw away white space after name
	ic = ngetc(c)
    while (i < defsiz & ic ^= NEWLINE & ic ^= SHARP & ic != EOF) {
	defstr(i) = c
	if (c == BACKSL) {        	# use \ to continue definition
	    if (ngetc(c) ^= NEWLINE) {	# to next line
		call putbak(c)
		i = i + 1
		}
	    }
	else
	    i = i + 1
	ic = ngetc(c)
	}
    defstr(i) = EOS
    if (i == defsiz) {
	call synerr("Definition too long.")
	getdef = NO
	}
    if (ic == SHARP)			# let rdtok flush comment
	call putbak(c)

    return
    end

#----------------------------------------------------------------------
# undef - Remove an existing definition
#----------------------------------------------------------------------

subroutine undef(tokstr, toksiz)
integer toksiz
character tokstr(toksiz)

intfunc flushl, rdtok
logfunc uninst

    integer ic

    ic = rdtok(tokstr, toksiz)
    if (ic ^= ALPHA)
	call synerr("Invalid name in 'undef'.")
    else if (^uninst(tokstr))
	call synerr("Name to 'undef' does not exist.")

    if (ic ^= EOF & ic ^= NEWLINE)
	ic = flushl(tokstr, toksiz)

    return
    end # of undef
