# drmax - definitions of array sizes, etc. for Ratfor.
#
# Copyright (c) 1988 by Michael J. Harrison
#
# Revised MJH, 16-Apr-88: New define syntax
# Revised MJH, 11-Dec-90: Add MAXMAC for ANSI C macro semantics
# M.J.Harrison  6-Apr-98: Additions for Linux/f2c

ifndef BYTEMASK
include "dmach.i"
endif

define MAXSTACK 50	# depth of statement nesting
define MAXDEF 256	# max length of a definition
define MAXTOK 256	# max length of a token
define BUFSIZE (2 * MAXTOK)	# putback buffer
define MAXMAC 10	# max depth of macro replacement nesting
define MAXFILES (9 + MAXMAC)	# 1 + max no. of files open at once (cdefio)
define MAXCHARS 14	# to hold 32-bit integer digits
define MINLAB 23000	# start number for labels
define MAXPNAME 16	# max parameter name len = 15
define MAXVNAME 7	# max variable name len = 6
define MAXSTRS 512	# save space for 'string' strings
define MAXFOR 10	# max nesting of 'for' statements
define MAXREINIT 256	# save space for 'for' reinit strings

define CHARSET 128	# size of character set (ASCII)
define CHARMASK (CHARSET-1)	# mask to AND character with

ifdef MSFORT4
define SRCEXT "R"	# default extension for source file
define INCEXT "I"	# default extension for include file
define FOREXT "FOR"	# default extension for FORTRAN output
define LSTEXT "LST"	# default extension for listing output
endif
ifdef UNIX
define SRCEXT "r"	# default extension for source file
define INCEXT "i"	# default extension for include file
define FOREXT "f"	# default extension for FORTRAN output
define LSTEXT "lst"	# default extension for listing output
endif
