# eatup - process rest of stmt, interpret continuations
#
# Copyright (c) 1987 by Michael J. Harrison
#
# Revised MJH,	2-Feb-86: No error for {, to handle new do without parens
#			  (Should really be controlled by argument to eatup)
# Revised MJH, 24-May-86: Support real CHARACTER variables
# Revised MJH, 20-Jun-86: Remove linect fudge
# Revised MJH, 10-Jan-87: Switch to common tokbuf and ptkbuf arrays
# Revised MJH, 20-Jul-87: Backed out fix for MS FORTRAN 4.00 bug
# M.J.Harrison 10-Apr-98: Linux

include dstd
include drmax
include drmeta

subroutine eatup

include ctoken
intfunc gettok

    integer nlpar, t

    nlpar = 0
    while (nlpar >= 0) {
	t = gettok(tokbuf, MAXTOK)
	if (t == EOF) {
	    call synerr("Unexpected end-of-file.")
	    break
	    }
	if (t == SEMICOL | t == NEWLINE)
	    break
	if (t == LBRACE | t == RBRACE) {
	    call pbstr(tokbuf)
	    break
	    }
	if ((t >= STAR & t <= COMMA) | t == AMPERSAND | t == EQUALS | t == VBAR) {
	    if (gettok(ptkbuf, MAXTOK) ^= NEWLINE)	# possible continuation
		call pbstr(ptkbuf)	# opNL == continuation
	    }
	else if (t == LPAREN)
	    nlpar = nlpar + 1
	else if (t == RPAREN)
	    nlpar = nlpar - 1
	call outstr(tokbuf)
	}
    if (nlpar ^= 0)
	call synerr("Unbalanced parentheses.")

    return
    end 	# of eatup
