#-----------------------------------------------------------------------
#
#  flushl - Read and throw away rest of line
#
#  Written MJH, 14-Jun-86:
#  M.J.Harrison 23-Apr-95: Add skipl, for ifeval (ifdpk.r)
#
#-------------- Copyright (C) 1986 by Michael J. Harrison --------------

include dstd

integer function flushl(tokstr, toksiz)
integer toksiz
character tokstr(toksiz)

intfunc rdtok		# Save unnecessary macro replacement overhead

    integer t

    t = rdtok(tokstr, toksiz)
    if (t ^= EOF)
	{
	if (t ^= NEWLINE)
	    {
	    call synerr("Extraneous material ignored.")
	    while (t ^= NEWLINE & t ^= EOF)
		t = rdtok(tokstr,toksiz)
	    }
	}
    if (t == EOF)
	call synerr("Unexpected end-of-file.")

    flushl = t
    return
    end # of flushl

#-----------------------------------------------------------------------
#  skipl: skip (rest of) line, return terminator (NEWLINE or EOF).
#-----------------------------------------------------------------------

integer function skipl(tokstr, toksiz)
integer toksiz
character tokstr(toksiz)

intfunc gettok

    integer t

    t = gettok(tokstr, toksiz)		# Must gettok because previous
    while (t ^= NEWLINE & t ^= EOF)	#   call to lex in ifeval may
	t = gettok(tokstr,toksiz)	#   have pushed >1 token

    skipl = t
    return
    end # of skipl
