# ifpk - routines for "if" statement: elseif, ifcode, ifend, ifgo
#
# Copyright (c) 1988-2005 by Michael J. Harrison
#
# Revised MJH,	8-Apr-87: Output FORTRAN-77 block IF for Ratfor if
# Revised MJH,  8-Sep-88: Replace ')' with char(RPAREN) in ifgo
# M.J.Harrison 10-Apr-98: Linux
# Mike Harrison 01/20/2005: Fix call to outch() in ifgo() (outch(46)
#			    passed INTEGER not INTEGER*1)

include dstd
include drmeta

#----------------------------------------------------------------------
# elseif -- generate code for end of "if" before "else"
#----------------------------------------------------------------------

subroutine elseif

    string elsest "ELSE"

    call ifout(elsest, 4)

    return
    end

#----------------------------------------------------------------------
# ifcode -- generate initial code for "if"
#----------------------------------------------------------------------

subroutine ifcode

    string ifst "IF", thenst "THEN"

    call outtab 		# get to col. 7
    call outstr(ifst)		# "IF"
    call balpar 		# collect and output (condition)
    call outstr(thenst) 	# "THEN"
    call outdon

    return
    end

#----------------------------------------------------------------------
# ifend -- generate code for final end of "if"
#----------------------------------------------------------------------

subroutine ifend

    string endist "ENDIF"

    call ifout(endist, 5)

    return
    end

#----------------------------------------------------------------------
# ifgo -- generate "IF(.NOT.(condition))GOTOlab"
#----------------------------------------------------------------------

subroutine ifgo(lab)

intrinsic char

    character rp
    integer lab
    string ifnot "IF(.NOT."

    call outtab 		# get to col. 7
    call outstr(ifnot)		# "IF(.NOT."
    call balpar 		# collect and output condition
    rp = RPAREN			# force character type (INTEGER*1)
    call outch(rp)		# ")"
    call outgo(lab)		# "GOTOlab"

    return
    end

#----------------------------------------------------------------------
# ifout -- local subroutine to output ELSE or ENDIF
#----------------------------------------------------------------------

subroutine ifout(str, m)
character str(m)
integer m

    call outtab 		# get to col. 7
    call outstr(str)
    call outdon

    return
    end
