# includ - process 'include' statement
# Copyright (C) 1988 by Michael J. Harrison
# Written MJH, 1979
# Revised MJH, 13-Jun-81: use current 'access' array
#			  translate filename to U/C before open.
# Revised MJH, 21-Dec-85: add default extension for include file
#			  allow only one filename per include (like C, not PL/I)
# Revised MJH,	6-Jun-86: STDERR changed to STDOUT
# Revised MJH, 20-Jun-86: Remove syner1 fudge
# Revised MJH, 16-Dec-86: Support the INCLUDE= environment variable
# Revised MJH, 26-Feb-87: Bug Fix - flush rest of line BEFORE switching
#			    to new source!
# Revised MJH, 16-Apr-88: Replace parameter statement by define

include dstd
include dmach	    # for LENxxx, STDOUT
include drmax

define MAXPATH (LENPATH + LENFULLFN)

subroutine includ(lexstr, ilevel, infid)
character lexstr(MAXTOK)
integer ilevel, infid

intfunc flushl, gettok, incopn

    integer newfid, t
    character fullnm(MAXPATH)
    string dflext INCEXT	# default extension for include file

    t = gettok(lexstr, MAXTOK)	# (include) filename
    if (t == NEWLINE | t == EOF)
	call synerr("Filename missing from 'include'.")
    else {
	call rfmkfn(lexstr, dflext, fullnm) # add ext if necessary
ifdef MSFORT4
	call trn2uc(fullnm)
endif
	t = flushl(lexstr, MAXTOK)  # flush rest of line
	newfid = incopn(fullnm)
	if (newfid < 0) {
	    call synerr("Cannot open 'include' file:.")
	    call putlin(fullnm, STDOUT)     # display its name
	    call putch(NEWLINE, STDOUT)
	    }
	else {
	    call opnget(newfid)     # allow ngetc/putbak (stack curr fid)
	    ilevel = ilevel + 1     # bump input level
	    infid = newfid	    # switch to new source
	    }
	}

    return
    end
