#-----------------------------------------------------------------------
#
#  outdon - finish off an output line	**MS-DOS**
#
#  Notes:
#   This routine depends on the operating system and FORTRAN compiler.
#   OS's have different conventions for end-of-line; some FORTRAN
#   compilers take varying length lines, others require all lines to
#   be 72 or 80 characters long, padded with blanks.
#
#  Written MJH,  1-Jun-86:
#  Revised MJH,  6-Jun-86: STDOUT now automatically line buffered
#  Revised MJH,  9-Sep-88: For INTEGER*1 chars
#  Revised MJH,  3-Jan-91: Use CHARMASK
#  M.J.Harrison 10-Apr-98: Linux
#
#-------------- Copyright (C) 1986 by Michael J. Harrison --------------

include dmach
include dstd
include dmetac
include drmax

subroutine outdon

include coutln

    integer i, ic
    integer lfofid, loutp	# local copies to speed up loop

    lfofid = fofid
    loutp = outp

    # MS FORTRAN allows varying length lines (terminated by CR-LF).
    for (i = 1; i <= loutp; i = i + 1) {
	ic = outbuf(i)			# Ensure integer
	ic = IAND(ic, BYTEMASK)		# Nullify any sign extension
	call putch(ic, lfofid)
    }

    # MS-DOS requires lines to be ended with CR-LF.
    # We are writing an output file in binary mode, unless it's STDOUT.
ifdef MSFORT4
    if (lfofid ^= STDOUT)
	call putch(CR, lfofid)
endif
    call putch(LF, lfofid)

    outp = 0

    return
    end
