# parest - process rest of Ratfor statement (after first token)
#
# Copyright (c) 1987 by Michael J. Harrison
#
# Revised MJH, 22-Dec-85: Support include with just one filename

include dstd
include drmax
include drmeta
include dlex

subroutine parest(lextok, lexstr, lextyp, labval, sp, lab)
integer lextok, lextyp(MAXSTACK), labval(MAXSTACK), sp, lab
character lexstr(MAXTOK)

intfunc flushl, lex

    integer junk

    if (lextok == LEXIF | lextok == LEXELSE | lextok == LEXWHILE |
	lextok == LEXFOR | lextok == LEXREPEAT | lextok == LEXDO |
	lextok == LEXLBRACE | lextok == LEXDIGITS) {
	sp = sp + 1	    # start of stmt
	if (sp > MAXSTACK)
	    call error("Stack overflow in parser (parse).")
	lextyp(sp) = lextok	    # stack type
	labval(sp) = lab	    # and value
	lextok = lex(lexstr, MAXTOK)
	}
    else {		    # end of stmt, prepare to unstack
	if (lextok == LEXRBRACE) {
	    if (lextyp(sp) == LEXLBRACE)
		sp = sp - 1
	    else
		call synerr("Illegal '}'.")
	    }
	else if (lextok == LEXUNTIL) {
	    if (lextyp(sp) == LEXREPEAT) {
		call untilc(labval(sp))
		sp = sp - 1	    # pop 'repeat' as well
		}
	    else {
		call synerr("Illegal 'until'.")
		junk = flushl(lexstr, MAXTOK)	# flush to NEWLINE
		}
	    }
	else if (lextok == LEXOTHER)
	    call otherc(lexstr)
	else if (lextok == LEXBREAK | lextok == LEXNEXT)
	    call brknxt(sp, lextyp, labval, lextok)
	lextok = lex(lexstr, MAXTOK)
	call unstak(sp, lextyp, labval, lextok)
	}

    return
    end
