# parnst - detect and process start of non-executable Ratfor statement
#
# Copyright (c) 1988 by Michael J. Harrison
#
# Note: all these statements are flushed to NEWLINE by the
#	respective handlers
# Revised MJH, 23-Dec-85: Adapt to new include
# Revised MJH, 14-Jun-86: Add ifdef, ifndef, endif, undef
# Revised MJH, 11-Apr-88: Retire the 'parameter' statement

include dstd
include drmax
include dlex

subroutine parnst(lextok, lexstr, ilevel, infid, ifdlvl)
integer lextok
character lexstr(ARB)
integer ilevel, infid, ifdlvl

    logical nonex

    nonex = YES
    if (lextok == LEXDEFINE)
	call define(lexstr, MAXTOK)
    else if (lextok == LEXSTRING)
	call string(lexstr, MAXTOK)
    else if (lextok == LEXINCLUDE)
	call includ(lexstr, ilevel, infid)
    else if (lextok == LEXIFDEF | lextok == LEXIFNDEF)
	call ifeval(lextok, lexstr, MAXTOK, ifdlvl)
    else if (lextok == LEXENDIF)
	call endif(lexstr, MAXTOK, ifdlvl)
    else if (lextok == LEXUNDEF)
	call undef(lexstr, MAXTOK)
    else
	nonex = NO

    if (nonex)
	lextok = LEXNONEXEC

    return
    end
