# parse -- parse Ratfor source program
#
# Copyright (c) 1987 by Michael J. Harrison
#
# Revised MJH, 22-Dec-85: Support include with just one file
# Revised MJH, 14-Jun-86: Move ilevel from cline to local data, add ifdef etc.
# Revised MJH, 10-Jan-87: Switch to common tokbuf array
# Revised MJH,	8-Apr-87: Remove parxst arg labval (for FORTRAN-77 block IF)

include dstd
include drmax
include dlex

subroutine parse(srcfid)
integer srcfid

include cline
include ctoken
intfunc clnget, lex
logfunc parxst

    integer lab, labval(MAXSTACK), lextyp(MAXSTACK), sp, lextok
    integer ifdlvl, ilevel, infid, oldfid, oldsp

    infid = srcfid
    lextyp(1) = EOF
    labval(1) = 1
    sp = 1
    ilevel = 1
    ifdlvl = 0

    lextok = lex(tokbuf, MAXTOK) # Get the first token
    while (ilevel > 0) {	# Loop over main input

	# scan current input file to its EOF
	oldsp = sp		# So we can check after include
	while (lextok ^= EOF) {
	    # if not executable stmt, try non-executable
	    if (^parxst(lextok, tokbuf, lextyp, sp, lab))
		call parnst(lextok, tokbuf, ilevel, infid, ifdlvl)

	    # If non-executable, read next token, else parse rest.
	    # If was include stmt, this will read from include file.
	    if (lextok == LEXNONEXEC)
		lextok = lex(tokbuf, MAXTOK)
	    else
		call parest(lextok, tokbuf, lextyp, labval, sp, lab)
	    } # end of while loop (current input file)

	ilevel = ilevel - 1

	# If ilevel > 0, we have just finished reading an include file.
	# The last token we read from the including file was (include)
	# filename; the next token should be NEWLINE.
	if (ilevel > 0) {
	    if (sp ^= oldsp) {		# Check and fix up after include
		call synerr("Premature end of include file.")
		sp = oldsp
		}
	    oldfid = clnget(infid)	# close ngetc/putbak and
	    call close(infid)		# close current include file
	    infid = oldfid		# switch back to previous source file
	    lextok = lex(tokbuf, MAXTOK)    # and read token from it
	    }

	} # end of main loop

    if (sp ^= 1)
	call synerr("Premature end of main file.")
    if (ifdlvl ^= 0)
	call synerr("Missing 'endif'.")

    return
    end
