# rchknm - check token obeys rules for name, return clean name.
#	   first char alpha, rest alphanumeric, < 'namlen' chars
#
# Copyright (c) 1988 by Michael J. Harrison
#
# Revised MJH, 31-May-86: Use common type array
# Revised MJH,  9-Sep-88: For INTEGER*1 chars
# Revised MJH,  3-Jan-91: Use CHARMASK
# M.J.Harrison 10-Apr-98: Linux

include dstd
include drmax

logical function rchknm(tokstr, name, namlen)
integer namlen
character tokstr(ARB), name(namlen)

include ctype

    integer i, t, ctype

    rchknm = NO
    ctype = ALPHA
    for (i = 1; i < namlen & tokstr(i) ^= EOS; i = i + 1) {
	t = tokstr(i)
	t = type(1 + IAND(t, CHARMASK))
	if (t == ALPHA | t == ctype)
	    name(i) = tokstr(i)
	else
	    break
	ctype = DIGIT
	}
    if (tokstr(i) == EOS)
	rchknm = YES
    else if (i >= namlen)
	call synerr("Name too long, truncated.")
    else
	call synerr("Illegal character in name.")
    name(i) = EOS

    return
    end
