# reppk - routines for 'repeat' statement: reptc, repts, untilc
#
# Copyright (c) 1987 by Michael J. Harrison

include dstd

#----------------------------------------------------------------------
# reptc - generate initial code for 'repeat'
#----------------------------------------------------------------------

subroutine reptc(lab)
integer lab

integer labgen

    call outcon(0)	    # unlabelled continue, in case there was label
    lab = labgen(3)
    call outcon(lab + 2)    # loop-back label for 'repeat'

    return
    end

#----------------------------------------------------------------------
# repts - generate code for end of 'repeat' with no 'until'
#----------------------------------------------------------------------

subroutine repts(lab)
integer lab

    call outnum(lab)	    # target for any 'next'
    call outgo(lab + 2)     # loop back
    call outcon(lab + 1)    # target for any 'break'

    return
    end

#----------------------------------------------------------------------
# untilc - generate code for 'repeat' terminated by 'until'
#----------------------------------------------------------------------

subroutine untilc(lab)
integer lab

    call outnum(lab)	    # target for any 'next'
    call ifgo(lab + 2)	    # conditional loop back
    call outcon(lab + 1)    # target for any 'break'

    return
    end
