#-----------------------------------------------------------------------
#
#  close - Close a file given its handle
#
#  Synopsis:	call close(handle)
#		int	handle	file handle (was returned by open)
#		Returns: if success, handle is set to 0
#			 else,	     handle is not altered
#
#  Written MJH, 27-Nov-85:  Version with UNIX-size buffers
#  Revised MJH,  5-Dec-85:  Flush buffer only if dirty
#  Revised MJH, 16-Feb-87:  Use rpclos instead of pfclos
#  Revised MJH, 21-Dec-87:  Implement uniform file system
#  M.J.Harrison 10-Apr-98:  Remove declaration for error (Linux)
#  M.J.Harrison 30-Sep-98:  Change STDMAX to STDERR, for Linux
#
#-------------- Copyright (C) 1985 by Michael J. Harrison --------------

include dstd
include dmach	# for STDERR, STDMAX

subroutine close(handle)
integer handle

intfunc rpclos
subrtn	putch

include cpfile

    integer doshdl,	# DOS handle
	    idx,	# index to file control block
	    retval	# function return value


    # Allow for handle offset from open.
    # If file was in fact opened ...

    idx = handle + 1
    doshdl = dosfid(idx)
    if (doshdl ^= FREESLOT) {

	# If dirty buffer, flush it.

	if (wflag(idx))
	    call putch(EOF, handle)

	# Close file.  If close successful,
	# reset file control block and set handle to zero.
	# However, if it's a STDxxx file, don't close it.

	if (doshdl > STDERR) {
	    retval = rpclos(doshdl)

	    if (retval >= 0) {
		handle = 0
		if (doshdl > STDMAX) {
		    nextc(idx) = 0
		    curcnt(idx) = 0
		    omode(idx) = 0
		    devflg(idx) = 0
		    dosfid(idx) = FREESLOT
		    wflag(idx) = NO
		    dospos(idx) = 0
		}
	    }
	}
    }

    return

    end 	# of close
