#  CPFILE - Common area for file primitives  **Linux**
#
# Copyright (c) 1988 by Michael J. Harrison
#
#  Written MJH, 12-May-87: From cpfile4k.i
#  Revised MJH, 21-Dec-87: Add bufsiz array for uniform file system
#  Revised MJH, 17-Apr-88: New define statement
#  M.J.Harrison 09/30/1998: Linux: Only STDIN..STDERR
#
#  Copyright (C) 1987-1998 by Michael J. Harrison

# STDIN through STDERR are already opened by Linux, and are never closed
# by RFS.  2K is a good compromise buffer size.

ifndef BUFSIZE
define BUFSIZE 2048	    # One hard disk cluster's worth
define _NFILE 16	    # Enough for our purposes
define BUFTOT (BUFSIZE * _NFILE + 2048)
define FREESLOT (-1)	    # An unused control block has dosfid = -1
define CRFLAG 256	    # Create flag for pfopen
endif

# File control blocks:

  integer nextc(_NFILE)     # offset of next char in buffer(i)
  integer curcnt(_NFILE)    # number of characters last read into buffer(i)
  integer bufadr(_NFILE)    # address of buffer(i) (index into pfilb array)
  integer bufsiz(_NFILE)    # length in bytes of buffer(i)
  integer omode(_NFILE)     # open mode of file(i)
  integer devflg(_NFILE)    # file/device flag (0: file, 1: device)
  integer dosfid(_NFILE)    # Linux identifier (handle) for file(i)
  logical wflag(_NFILE)     # YES if buffer(i) has been changed (since read)
  integer dospos(_NFILE)    # buffer number (from 0); -1 => opened but no I/O
common /cpfile/ nextc, curcnt, bufadr, bufsiz, omode,
		devflg, dosfid, wflag, dospos

# Actual buffer storage:

  character pfilb(BUFTOT)
common /cpfilb/ pfilb
