#-----------------------------------------------------------------------
#
#  error - Send error message to STDOUT, then terminate
#
#  Synopsis:	call  error(msg)
#		char(*) msg	    Error msg (ASCIIZ with ".")
#
#  Purpose:	Deal with fatal error condition
#
#  Notes:	Call rpwrit directly to avoid putch -> error -> remark -> putch
#
#  Method:	Find length of message.  Output message, STOP.
#
#  Written MJH, 17-Nov-85:
#  Revised MJH, 29-Nov-85: Call pfwrit directly
#  Revised MJH, 24-May-86: Support true CHARACTER variables
#  Revised MJH,  6-Jun-86: Output destination changed from STDERR
#  Revised MJH, 16-Feb-87: Use rpwrit instead of pfwrit
#  Revised MJH, 14-Mar-87: Use STOP for Microsoft FORTRAN 4.00
#  Revised MJH, 22-Jul-87: Replace CR, LF with metacharacter equivalents
#  Revised MJH,  5-Aug-87: Replace STOP with call to mfretc
#  Revised MJH, 17-Apr-88: New define syntax
#  Revised MJH, 12-Sep-88: Handle null error message
#
#-------------- Copyright (C) 1985 by Michael J. Harrison --------------

include dstd
include dmach		# For STDOUT
include dmetac		# For CR, LF
define LEMSG 256	# Longest message we will write

subroutine error(msg)
character msg(ARB)

intfunc rpwrit

    integer i, j
    character lclmsg(LEMSG)

    if (msg(1) ^= PERIOD) {	# Output message if non-null
	lclmsg(1) = CR		# Make sure we start at left margin

	j = 2			# Index to lclmsg
	for (i = 1; j <= LEMSG & msg(i) ^= PERIOD; i = i + 1) {
	    if (msg(i) == ESCFLAG)
		i = i + 1
	    lclmsg(j) = msg(i)
	    j = j + 1
	}

	if (j >= LEMSG)
	    j = LEMSG - 1
	lclmsg(j) = CR
	j = j + 1
	lclmsg(j) = LF
	i = rpwrit(STDOUT, lclmsg, j)
    }

    call mfretc(16)	# ****** Don't return to caller - bail out ******

    end # of error
