#-----------------------------------------------------------------------
#
#  fhdate     - Get or set file date and time using file handle
#  Synopsis:	err = fhdate(flag, handle, fdate, ftime)
#		int	err	0 => OK, < 0 => -(DOS error code)
#		int	flag	0 => get date, 1 => set date
#		int	handle	file handle (was returned by open)
#		int*4	fdate	file date yyyymmdd (e.g. 19851210)
#		int*4	ftime	file time hhmmss (24-hr clock)
#
#  Notes:	Only reason for this is to translate Ratfor handle
#		to DOS handle.
#
#  Written MJH, 10-Dec-85
#  Revised MJH,  5-Apr-87: pf... --> rp...
#  M.J.Harrison 05/30/1999: Avoid compilation warning
#
#-------------- Copyright (C) 1985 by Michael J. Harrison --------------

include dstd
include derrno

integer function fhdate(flag, handle, fdate, ftime)
integer flag, handle
integer*4 fdate, ftime

intfunc rpfdat
include cpfile

    integer dosfh	# DOS file handle

    # Allow for handle offset from open.
    dosfh = dosfid(handle + 1)

    # If file was in fact opened, call primitive
    if (dosfh ^= FREESLOT)
	fhdate = rpfdat(flag, dosfh, fdate, ftime)
    else {
	fhdate = -REBADF
	if (flag == 0) {
	    fdate = 0
	    ftime = 0
	}
    }

    return

    end 	# of fhdate
