#  fnmtch - Test if filename matches wild-card pattern (by MS-DOS rules)
#
# Copyright (c) 1988 by Michael J. Harrison
#
#  Written MJH, 10-Sep-88: Copyright (C) 1988 by Michael J. Harrison

include dstd
include dmetac

logical function fnmtch(fname, fpatt)
character fname(ARB)		# Filename
character fpatt(ARB)		# Pattern with wild cards
#
#  Returns: YES if match, NO otherwise

intfunc fpsplt

    integer i, j
    logical match

    # Match filename portion (up to . or EOS)
    i = 1
    j = fpsplt(fpatt)		# Step over any path in pattern
    match = YES
    while (match & fname(i) != PERIOD & fname(i) != EOS) {
	if (fname(i) == fpatt(j) | fpatt(j) == QMARK) {
	    i = i + 1
	    j = j + 1
	} else {
	    if (fpatt(j) == STAR) {
		while (fname(i) != PERIOD & fname(i) != EOS)
		    i = i + 1
		while (fpatt(j) != PERIOD & fpatt(j) != EOS)
		    j = j + 1
	    } else
		match = NO
	}
    }

    # If that matched, try extension portion
    if (match) {
	if (fname(i) == EOS) {		# xxxE matched by xxxE or
	    if (fpatt(j) == PERIOD)	# xxx.E (E == EOS)
		j = j + 1
	    if (fpatt(j) != EOS)
		match = NO
	} else if (fpatt(j) == EOS) {	# xxx.E matched by xxxE
	    if (fname(i+1) != EOS)
		match = NO
	} else {
	    while (match & fname(i) != EOS & fpatt(j) != STAR) {
		if (fname(i) == fpatt(j) | fpatt(j) == QMARK) {
		    i = i + 1
		    j = j + 1
		} else
		    match = NO
	    }
	    if (match) {
		if (fpatt(j) != EOS & fpatt(j) != STAR)
		    match = NO
	    }
	}
    }

    fnmtch = match
    return
end	#  of fnmtch
