#-----------------------------------------------------------------------
#
#  getarg - Package for getting command line arguments
#
#  Notes:
#   The variable "reread" gets its name from the original DEC-20
#   implementation where it was necessary to reread the terminal input.
#
#  Written MJH, 1979:	   For the DEC-20 implementation
#  Revised MJH, 23-May-86: Adapt for true CHARACTER variables
#  Revised MJH, 31-May-86: Name the Block Data subprogram
#  Revised MJH, 16-Feb-87: Use rpargs instead of pfargs
#  M.J.Harrison  3-Apr-98: Linux: character comparisons
#
#-------------- Copyright (C) 1986 by Michael J. Harrison --------------

include dmach
include dstd
include dmetac

#-----------------------------------------------------------------------
# getarg - get next argument from command line
#-----------------------------------------------------------------------

integer function getarg(argstr, maxlen)
integer maxlen
character argstr(maxlen)

intfunc rpargs			# primitive function to get arguments
include carg

    integer i
    character quote

    if (reread)
	{
	reread = NO		    # first call only
	i = rpargs(buffer(1))
	buffer(i + 1) = EOS	    # mark end of args
	bufp = 1
	}

    while (buffer(bufp) == BLANK | buffer(bufp) == HT)
	bufp = bufp + 1 	    # skip over leading white space
    i = 1			    # initialize argstr placer
    if (buffer(bufp) == SQUOTE | buffer(bufp) == DQUOTE) # quoted argument
	{
	quote = buffer(bufp)
	for (bufp = bufp + 1; buffer(bufp) ^= quote; bufp = bufp + 1)
	    {
	    if (buffer(bufp) == EOS)
		call error("Missing quote in argument.")
	    if (i < maxlen)
		{
		argstr(i) = buffer(bufp)
		i = i + 1
		}
	    }
	bufp = bufp + 1 	      # step over closing quote
	}
    else {			       # unquoted argument
	for (; buffer(bufp) ^= BLANK & buffer(bufp) ^= HT &
	       buffer(bufp) ^= EOS; bufp = bufp + 1)
	    {
	    if (i < maxlen)
		{
		argstr(i) = buffer(bufp)
		i = i + 1
		}
	    }
	}
    argstr(i) = EOS
    if (buffer(bufp) == EOS & i == 1)
	getarg = EOF
    else
	getarg = i - 1

    return
    end 	# of getarg


#-----------------------------------------------------------------------
# cargbd - block data for getarg
#-----------------------------------------------------------------------

    block data cargbd

    include carg
    data reread /YES/

    end 	# of cargbd
