#-----------------------------------------------------------------------
#
#  initgp     - Init the CPFILE common area for Get/Put
#
#  Synopsis:	call initgp
#
#  Written MJH, 27-Nov-85:  Version with UNIX-size buffers
#  Revised MJH, 26-Jan-86:  New treatment of dospos
#  Revised MJH, 21-Dec-87:  New buffer sizes, unified file system
#  Revised MJH, 17-Apr-88:  Replace parameter statement by define
#  M.J.Harrison 09/30/1998: Linux: Only STDIN..STDERR preopened
#
#-------------- Copyright (C) 1985 by Michael J. Harrison --------------

include dstd
include dstdio	    # for INPUT, OUTPUT
include dmach	    # for STDMAX


subroutine initgp

intfunc isatty

include cpfile

    integer i
    integer curadr	# address of current buffer
    define NUMSTD (STDMAX + 1)
    integer stdomo(NUMSTD)	# Open modes for STDxxx (all TEXTMODE)
    integer stdbsz(NUMSTD)	# Buffer sizes for STDxxx
    data stdomo /INPUT, OUTPUT, OUTPUT/
    data stdbsz / 2048,   2048,   2048/
    # For:	 STDIN	STDOUT	STDERR

    # Open STDIN through STDMAX

    curadr = 1
    do i = 1, NUMSTD {
	nextc(i) = 0
	curcnt(i) = 0
	bufadr(i) = curadr
	bufsiz(i) = stdbsz(i)
	curadr = curadr + stdbsz(i)	# Next buffer address
	omode(i) = stdomo(i)
	devflg(i) = isatty(i - 1)
	dosfid(i) = i - 1
	wflag(i) = NO			# Flag virgin buffer
	dospos(i) = -1			# Flag no I/O yet
    }

    # Init other file control blocks

    do i = NUMSTD + 1, _NFILE {
	nextc(i) = 0
	curcnt(i) = 0
	bufadr(i) = curadr		# Assign buffer address
	bufsiz(i) = BUFSIZE		# Set buffer size
	curadr = curadr + BUFSIZE	# Next buffer address
	omode(i) = 0
	devflg(i) = 0
	dosfid(i) = FREESLOT
	wflag(i) = NO
	dospos(i) = 0
    }

    return

    end		# of initgp
