#-----------------------------------------------------------------------
#
#   itoc - convert long integer to character form
#
#   Notes:
#	"size" must be >= m+1 if n >= 0 and >= m+2 if n < 0
#	where integer n can be held in m digits.
#	If it's too small, the number is truncated.
#
#   Written MJH, 23-Jul-86: Standard header etc. added
#
#-------------- Copyright (C) 1986 by Michael J. Harrison --------------

include dstd

integer function itoc(int, str, size)
integer*4 int		# Integer to convert
integer size		# Length of target string, incl. EOS
character str(size)	# Target string
			# size < 0 means insert leading zeros to fill field
#
#   Returns: Actual number of characters used (excluding EOS)

     integer*4 intval
     integer d, i, j, len
     logical zeros	# Set TRUE if leading zeros desired
     character c
     string digits "0123456789"

     # Get absolute value, set flag for leading zeros
     #
     intval = iabs(int)
     len = iabs(size)
     zeros = (size < 0)

     # Generate digits in reverse order
     #
     str(1) = EOS
     i = 1
     repeat {
	  i = i + 1
	  d = mod(intval, 10)
	  str(i) = digits(d + 1)
	  intval = intval / 10
	  } until ((!zeros & intval == 0) | i >= len)

     # Add minus sign if negative, set length used
     #
     if (int < 0 & i < len) {
	  i = i + 1
	  str(i) = ICHAR('-')
	  }
     itoc = i - 1

     # Reverse digits in target (work from ends to middle).
     #
     for (j = 1; j < i; j = j + 1) {
	  c = str(i)
	  str(i) = str(j)
	  str(j) = c
	  i = i - 1
	  }

     return
     end # of itoc
