#-----------------------------------------------------------------------
#
#  REMARK     - Send message to STDOUT
#  Synopsis:	call  REMARK(msg)
#		CHAR(*) msg	Error msg (ASCII terminating with ".")
#
#  Purpose:	Output byte-string message (usually error)
#  Notes:	A period within the message may be escaped with "~"
#		Only up to 255 characters will be output (for safety)
#  Method:	Output message to STDOUT
#  Written MJH, 17-Nov-85:
#  Revised MJH, 23-May-86:  Adapt for true CHARACTER variables
#  Revised MJH,  6-Jun-86:  Output destination changed from STDERR
#  Revised MJH,  9-Sep-88:  Mask int to 8 bits for INTEGER*1 chars
#  M.J.Harrison  3-Apr-98:  Linux: character comparisons
#
#-------------- Copyright (C) 1985 by Michael J. Harrison --------------

include dmach	    # for STDOUT
include dstd
include dmetac

#****** Procedure Entry ******#

subroutine REMARK(msg)
character msg(ARB)

#====== Externals ======#

subrtn putch

    #====== Local Declarations ======#

    integer i, ic

    #====== Executable Code ======#

    for (i = 1; i < 256 & msg(i) ^= PERIOD; i = i + 1)
	{
	if (msg(i) == ESCFLAG)
	    i = i + 1
	ic = msg(i)			# Ensure integer
	ic = IAND(ic, BYTEMASK)		# Nullify any sign extension
	call putch(ic, STDOUT)
	}
    call putch(NEWLINE, STDOUT)

    return
    end # of REMARK
