# rpargs - retrieve command line arguments
#
# Mike Harrison 10/15/2006: Initial implementation
#
# The original awkward design for getting command line arguments,
# forced by the peculiar way it had to be done for the first
# TOPS-20 implementation, comes back to bite us in the ass.
# The iargc/getarg trick that worked for g77 does not work for
# f95, so we use these F2003 features instead (and live with
# the compilation warning).
#
# (c) Copyright Michael J. Harrison 2006. All rights reserved.

include dstd
include dmetac

# Retrieve tha command line arguments, returning them in a
# buffer supplied by the caller, each argument being separated
# from the next by one blank and the whole string being terminated
# by a NUL. No individual argument may be longer than 128
# characters. The function return value is the length of the
# the whole argument string as returned in the buffer.

integer function rpargs(resbuf)
character resbuf(ARB)
    intfunc rpxfer
    CHARACTER(len = 128) :: buf
    integer argc, i, j

    argc = COMMAND_ARGUMENT_COUNT()
    j = 1
    for (i = 1; i <= argc; i = i + 1) {
	if (i > 1) {
	    resbuf(j) = BLANK
	    j = j + 1
	}
	call GET_COMMAND_ARGUMENT(i, buf)
	j = j + rpxfer(TRIM(buf), resbuf(j), LEN_TRIM(buf))
    }
    resbuf(j) = NUL
    rpargs = j
    return
    end
