#-----------------------------------------------------------------------
#
#  setmod     - Set translation mode of open file
#
#  Synopsis:	int setmod(handle, fmode)
#		int	handle	file handle
#		int	fmode	O_TEXT	 0x0000  text (CR/LF <--> NEWLINE)
#				O_BINARY 0x0004  binary (CR/LF untranslated)
#		Returns: if success, old fmode; else -1, code in errno
#
#  Written MJH, 14-Jul-86:  From open
#
#-------------- Copyright (C) 1986 by Michael J. Harrison --------------

include dstd
include dstdio
include derrno

integer function setmod(handle, fmode)
integer handle		# file handle
integer fmode		# new mode to set

include cpfile
include cerrno

    integer idx,	# index to file control block
	    mode,	# open mode, including BIN/TEXT flag
	    retval	# our return value

    # Check handle for valid range
    idx = handle + 1
    if (idx < 1 | idx > _NFILE)
	{
	retval = -1
	errno = REBADF		# Bad file handle
	}
    else
	{
	# Check fmode valid
	if (fmode ^= O_TEXT & fmode ^= O_BINARY)
	    {
	    retval = -1
	    errno = REINVMODE	# Invalid file translation mode
	    }
	else
	    {
	    # Get current translate fmode, remove O_BINARY if there
	    retval = 2 * O_BINARY	# use retval to hold this temporarily
	    mode = omode(idx) - retval * (omode(idx) / retval)
	    if (mode < O_BINARY)
		retval = O_TEXT
	    else
		{
		retval = O_BINARY
		mode = mode - O_BINARY
		}

	    # Set new mode
	    omode(idx) = mode + fmode
	    }
	}

    setmod = retval
    return

    end # of setmod
